#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>

//el codigo esta identado con tabs de tamaño 4.

volatile int plot=0,end=0; //flags para que las rutinas de interrupcion sean cortas

void  SignalHandler(int sig){ //manejo de señales
	if(sig==SIGALRM)
		plot=1;
	if(sig==SIGINT)
		end=1;
}

int main( int argc, const char* argv[])
{	
	if(argc !=5){
		printf("Numero incorrecto de parametros \n");
		exit(1);
	}

	signal(SIGALRM, SignalHandler);
	signal(SIGINT, SignalHandler);
	
	struct timespec t; //variables para pequeño descanso, para no hacer "busy wait"
	t.tv_sec = 0;
   	t.tv_nsec = 100000000;

	int i, status, cont=1;
	FILE *pf, *sd; //pf para comunicar con ping y sd para comunicar con octave
	char line[200], paquete[10], tiempo[10]; //linea para lectura, paquete y tiempo son la informacion relevante que entrega ping
	double estRetardo=0.0, estDesviacion=0.0, estRReproduccion[4]; //estimadores a calcular, estRReproduccion[1] significa N-1
	float prr[4]; //porcentajes a enviar por correo

	for(i=0;i<4;i++)
		prr[i]=0.0;
		
	pid_t pid; //pid ping
	int pfd[2]; //para pipa con octave

	strcpy(line,"ping -i  0.2 "); //armar comando ping
	strcat (line,argv[1]);

    if ((pf = popen(line, "r")) == NULL) { //iniciar ping
        perror("popen");
        exit(1);
    }

    if (pipe(pfd) < 0) { //crear pipa
        perror("pipe");
        exit(1);
    }

    if ((pid = fork()) < 0) {	//crear proceso hijo
        perror("fork");
        exit(1);
    }

    if (pid == 0) { //mutar el hijo en octave
    	int junk;
        dup2(pfd[0], 0);
        close(pfd[1]);  
        junk = open("/dev/null", O_WRONLY);
        dup2(junk, 1);  
        dup2(junk, 2);  
        execlp("octave", "octave", "-i", NULL);
        perror("exec");
        exit(-1);
    }

    close(pfd[0]); //no se va a leer,
	sd = fdopen(pfd[1], "w");		 //solo escribir.

	fprintf(sd, "d=zeros(1,1);\n");
	fprintf(sd, "v=zeros(1,1);\n");
	fprintf(sd, "rr1=zeros(1,1);\n");
	fprintf(sd, "rr2=zeros(1,1);\n");
	fprintf(sd, "rr3=zeros(1,1);\n");
	fprintf(sd, "rr4=zeros(1,1);\n");
	fprintf(sd, "retardo=zeros(1,1);\n");
	fflush(sd);

	alarm(2); //setea alarma

	while(1){

    	if (fgets(line, sizeof(line), pf) == NULL) { //lectura desde ping
      	  fprintf(stderr, "Sin respuesta\n");
     	   exit(1);
   	 	}

		if(sscanf(line, "%*s %*[^=]%*c%s %*s %*[^=]%*c%s %*s", paquete, tiempo) == 2){ //obtencion de datos
      		estRetardo=0.98*estRetardo+0.02*atof(tiempo);						//calculo de estimadores
			estDesviacion=0.75*estDesviacion+0.25*fabs(atof(tiempo)-estRetardo);			
			for(i=0;i<4;i++){
				estRReproduccion[i]=estRetardo+(i+1)*estDesviacion;	
				if(estRReproduccion[i]-atof(tiempo)<0)
					prr[i]+=1;
			}

			fprintf(sd, "d(1,%d)=%f;\n",cont, estRetardo); //actualizacion de variables en octave
			fprintf(sd, "v=1,%d)=%f;\n",cont, estDesviacion);
			fprintf(sd, "rr1(1,%d)=%f;\n", cont, estRReproduccion[0]);
			fprintf(sd, "rr2(1,%d)=%f;\n", cont, estRReproduccion[1]);
			fprintf(sd, "rr3(1,%d)=%f;\n", cont, estRReproduccion[2]);
			fprintf(sd, "rr4(1,%d)=%f;\n", cont, estRReproduccion[3]);	
			fprintf(sd, "retardo(1,%d)=%s;\n",cont, tiempo);
			cont++;
			fflush(sd);
		}

		if(end==1){ //envio de correo

			for(i=0;i<4;i++) //calculo porcentaje perdido
				prr[i]=prr[i]*100/cont;

			fprintf(sd, "\n exit\n"); fflush(sd); //finaliza octave
			
			pid_t pid1;	//pid openssl
  			int pfdToChild[2];	//pipas para comunicacion con openssl
  			int pfdFromChild[2];
  			int status1;
  			char smtp[200],mail[200],datos[200]; //string con datos para el correo
  			int port=587;
  			FILE * toChild, *fromChild;

			strcpy(smtp,argv[2]);
			strcpy(mail,argv[3]);
			strcpy(datos,argv[4]);


			if (pipe(pfdToChild) < 0) {
   				perror("pipe");
    			exit(1);
  			}
  			if (pipe(pfdFromChild) < 0) {
    			perror("pipe");
   				exit(1);
  			}

  			if ((pid = fork()) < 0) {
    			perror("fork");
    			exit(1);
  			}

  			if (pid == 0) { //inicia openssl

    			dup2(pfdToChild[0], 0);  
    			close(pfdToChild[1]);
 
    			dup2(pfdFromChild[1],1); 
    			dup2(pfdFromChild[1],2); 
                        
    			close(pfdFromChild[0]);
    			sprintf(line,"%s:%i",smtp,port);  
    			execl("/usr/bin/openssl", "openssl", "s_client", "-starttls","smtp", "-crlf", "-connect", line, NULL);
    			perror("exec");
    			_exit(127);
  			}
  
  			close(pfdToChild[0]);
  			close(pfdFromChild[1]);
  			toChild = fdopen(pfdToChild[1], "w");
  			fromChild = fdopen(pfdFromChild[0], "r");

  			while (strncmp(fgets(line, sizeof(line), fromChild),"250 ",4)!=0); //envio de correo deacuerdo con la forma de gmail
  			fprintf(toChild,"AUTH PLAIN %s\n", datos);
  			fflush(toChild);
  			fgets(line, sizeof(line), fromChild);
  			printf("\tAGV AUTH\t%s\n", line);
  			fprintf(toChild,"mail from: <%s>\n",mail);
  			fflush(toChild);
  			fgets(line, sizeof(line), fromChild);
  			printf("\tAGV mail from\t%s\n", line);
  			fprintf(toChild,"rcpt to: <%s>\n",mail);  
  			fflush(toChild);
  			fgets(line, sizeof(line), fromChild);
  			printf("\tAGV rcpt to\t%s\n", line);
  			fprintf(toChild,"data\n");
  			fflush(toChild);
  			fgets(line, sizeof(line), fromChild);
  			printf("\tAGV data\t%s\n", line);

  			fprintf(toChild, "From:\"PAR\" %s\n\
				To: \"Cliente\" %s\nSubject: Paquetes atrasados\n\n\
N %%paquetes atrasados\n1 %.2f\n2 %.2f\n3 %.2f\n4 %.2f.\n.\n",mail,mail,prr[0],prr[1],prr[2],prr[3]);
  			fflush(toChild);

  			fgets(line, sizeof(line), fromChild);
  			printf("\tAGV\t%s\n", line);
  			fprintf(toChild,"quit\n");
  			fflush(toChild);
  			fgets(line, sizeof(line), fromChild);
  			printf("\tAGV quit\t%s\n", line);
    
  			fclose(toChild);
  			fclose(fromChild);
			fclose(sd);
			pclose(pf);
  			waitpid(pid1, &status1, 0);
			waitpid(pid, &status, 0);
   
  			exit(0);

		}

		if(plot==1){ //graficos
			plot=0;
			fprintf(sd, "subplot(2,1,1);\n");
			fprintf(sd, "hold on\n");
			fprintf(sd, "plot(d,\"1\");\n");
			fprintf(sd, "plot(rr1,\"2\");\n");
			fprintf(sd, "plot(rr2,\"2\");\n");
			fprintf(sd, "plot(rr3,\"2\");\n");
			fprintf(sd, "plot(rr4,\"2\");\n");
			fprintf(sd, "plot(retardo,\"@23\");\n");
			fprintf(sd, "hold off\n");
			fprintf(sd, "subplot(2,1,2);\n");
			fprintf(sd, "hist(retardo);\n");
			fflush(sd);
			alarm(5); //setea alarma, muy recomendado aumentar a 5 o 10.
		}

		 nanosleep(&t, NULL);//el descanso.
	}
}
